## mame 0.187+dfsg.1

=== debian/changelog ===
mame (0.187+dfsg.1-1) unstable; urgency=medium

  * New upstream release.
  * Release to unstable.
  * Use uscan to repack upstream tarball.
  * Removed whatsnew.txt and ctrlr/*.cfg files, no longer in repacked tarball.

 -- Cesare Falco <c.falco@ubuntu.com>  Mon, 03 Jul 2017 10:49:39 +0200

mame (0.186-1) unstable; urgency=medium

  * New upstream release.
  * Refresh patches.

 -- Cesare Falco <c.falco@ubuntu.com>  Sun, 04 Jun 2017 08:33:50 +0200

mame (0.185-1) experimental; urgency=medium

  * New upstream release.
  * Disable genie_freebsd_target.patch, as it gets in the way and kFreeBSD
    builds are broken in other ways.
  * Refresh patches.

 -- Jordi Mallach <jordi@debian.org>  Wed, 26 Apr 2017 12:11:22 +0200

mame (0.184-1) experimental; urgency=medium

  * New upstream release.

 -- Jordi Mallach <jordi@debian.org>  Fri, 07 Apr 2017 01:43:05 +0200

mame (0.183-1) experimental; urgency=medium

  * New upstream release.
  * Drop transitional mess and mess-data packages.
  * Extend mame-data's description slightly.

 -- Jordi Mallach <jordi@debian.org>  Tue, 07 Mar 2017 21:37:54 +0100

=== debian/control ===
Source: mame
Section: games
Priority: optional
Maintainer: Debian Games Team <pkg-games-devel@lists.alioth.debian.org>
Uploaders: Cesare Falco <c.falco@ubuntu.com>,
 Emmanuel Kasper <emmanuel@libera.cc>,
 Jordi Mallach <jordi@debian.org>
Build-Depends: debhelper (>= 10),
 dpkg-dev (>= 1.17),
 libexpat1-dev,
 libflac-dev,
 libfontconfig1-dev,
 libjpeg-dev,
 liblua5.3-dev,
 libportmidi-dev [linux-any],
 libsdl2-ttf-dev,
 libsdl2-dev,
 libsqlite3-dev,
 libutil-freebsd-dev [kfreebsd-any],
 libuv1-dev,
 libxinerama-dev,
 portaudio19-dev,
 python-dev,
 qtbase5-dev,
 zlib1g-dev
Build-Depends-Indep: python3-sphinx
Standards-Version: 3.9.8
Vcs-Git: https://anonscm.debian.org/git/pkg-games/mame.git
Vcs-Browser: https://anonscm.debian.org/cgit/pkg-games/mame.git
Homepage: http://mamedev.org/
XS-Autobuild: yes

Package: mame
Architecture: any
Depends: ${misc:Depends},
 ${shlibs:Depends},
 mame-data (= ${source:Version})
Replaces: mess (<< 0.162)
Breaks: mess (<< 0.162)
Suggests: gnome-video-arcade,
 mame-doc,
 mame-extra,
 mame-tools
Description: Multiple Arcade Machine Emulator (MAME)
 MAME is a hardware emulator: it faithfully reproduces the behavior of many
 arcade machines (it is not a simulation). This program is not a game but can
 directly, through ROM images, run the complete system of these old arcade
 machines. These ROMs are subject to copyright and it is in most of the cases
 illegal to use them if you do not own the arcade machine.
 .
 This package provides the MAME binary and configuration files.

Package: mame-data
Architecture: all
Depends: ${misc:Depends}
Replaces: mess-data (<< 0.162)
Breaks: mess-data (<< 0.162)
Description: Multiple Arcade Machine Emulator (MAME) -- data files
 MAME is a hardware emulator: it faithfully reproduces the behavior of many
 arcade machines (it is not a simulation). This program is not a game but can
 directly, through ROM images, run the complete system of these old arcade
 machines. These ROMs are subject to copyright and it is in most of the cases
 illegal to use them if you do not own the arcade machine.
 .
 This package provides MAME hash files, keymaps, artwork, language files,
 shaders, plugins and audio samples.

Package: mame-tools
Section: utils
Architecture: any
Depends: ${misc:Depends},
 ${shlibs:Depends}
Recommends: mame (= ${source:Version})
Description: Tools for MAME
 MAME is a hardware emulator: it faithfully reproduces the behavior of many
 arcade machines (it is not a simulation).
 .
 This package provides tools to be used with MAME. It currently contains:
  castool -- generic cassette manipulation tool for MAME
  chdman -- MAME Compressed Hunks of Data CHD manager
  floptool -- Generic floppy image manipulation tool for MESS
  imgtool -- generic image manipulation tool for MAME
  jedutil -- binary to/from JEDEC file converter
  ldresample -- Laserdisc audio synchronizer and resampler
  ldverify -- Laserdisc AVI/CHD verifier
  romcmp -- ROM comparison utility program

Package: mame-doc
Section: doc
Architecture: all
Depends: ${misc:Depends}
Suggests: libjs-sphinxdoc, libjs-mathjax
Enhances: mame
Description: Documentation for MAME
 MAME is a hardware emulator: it faithfully reproduces the behavior of many
 arcade machines (it is not a simulation).
 .
 This is sphinx-generated full documentation for the MAME system.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.
# Default/i386/amd64 options from sdlmame rules file by Cesare Falco.

#export DH_VERBOSE = 1

DEB_BUILD_ARCH ?= $(shell dpkg-architecture -qDEB_BUILD_ARCH)
DEB_HOST_ARCH_BITS ?= $(shell dpkg-architecture -qDEB_HOST_ARCH_BITS)

# Define DEB_HOST_MULTIARCH for QT prefix handling
DEB_HOST_MULTIARCH ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)

# add c++ hardening options (upstream makefile doesn't use CPPFLAGS)
export DEB_BUILD_MAINT_OPTIONS = hardening=+all
export DEB_CFLAGS_MAINT_APPEND = $(shell dpkg-buildflags --get CPPFLAGS)

# Sacrifice linking speed to avoid using so much memory
export DEB_LDFLAGS_MAINT_APPEND = -Wl,--no-keep-memory

# taken verbatim from debian policy
ifneq (,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
NUMJOBS = $(patsubst parallel=%,%,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
MAKEFLAGS += -j$(NUMJOBS)
endif

# Override relevant make variables in original makefile
DEB_OPTS = \
    NOWERROR=1 \
    OSD=sdl \
    DEBUG= \
    TARGETOS=linux \
    DISTRO=debian-stable \
    FORCE_DRC_C_BACKEND=1 \
    PTR64= \
    BIGENDIAN= \
    NOASM=1 \
    NO_USE_LINENOISE=1 \
    QT_HOME=/usr/lib/$(DEB_HOST_MULTIARCH)/qt5/ \
    USE_SYSTEM_LIB_EXPAT=1 \
    USE_SYSTEM_LIB_ZLIB=1 \
    USE_SYSTEM_LIB_JPEG=1 \
    USE_SYSTEM_LIB_FLAC=1 \
    USE_SYSTEM_LIB_LUA=lua5.3:/usr/include/lua5.3 \
    USE_SYSTEM_LIB_SQLITE3=1 \
    USE_SYSTEM_LIB_PORTMIDI=1 \
    USE_SYSTEM_LIB_PORTAUDIO=1 \
    USE_SYSTEM_LIB_UV=1 \
    VERBOSE=1

# Override make variables for specific archs
# Linux architectures
ifeq ($(DEB_HOST_ARCH),amd64)
DEB_OPTS += \
    FORCE_DRC_C_BACKEND= \
    PTR64=1 \
    NOASM=
endif

ifeq ($(DEB_HOST_ARCH),arm64)
DEB_OPTS += \
    ARCHOPTS="-mabi=lp64 -fPIC"
endif

ifeq ($(DEB_HOST_ARCH),i386)
DEB_OPTS += \
    FORCE_DRC_C_BACKEND= \
    NOASM=
endif

ifeq ($(DEB_HOST_ARCH),ia64)
DEB_OPTS += \
    PTR64=1
endif

ifeq ($(DEB_HOST_ARCH),mips)
DEB_OPTS += \
    ARCHOPTS=-Umips \
    BIGENDIAN=1
endif

ifeq ($(DEB_HOST_ARCH),mipsel)
DEB_OPTS += \
    ARCHOPTS=-Umips
endif

ifeq ($(DEB_HOST_ARCH),powerpc)
DEB_OPTS += \
    ARCHOPTS=-Upowerpc \
    NOASM= \
    BIGENDIAN=1
endif

ifeq ($(DEB_HOST_ARCH),ppc64)
DEB_OPTS += \
    PTR64=1 \
    NOASM= \
    BIGENDIAN=1
endif

ifeq ($(DEB_HOST_ARCH),ppc64el)
DEB_OPTS += \
    PTR64=1 \
    NOASM=
endif

ifeq ($(DEB_HOST_ARCH),s390)
DEB_OPTS += \
    BIGENDIAN=1
endif

ifeq ($(DEB_HOST_ARCH),s390x)
DEB_OPTS += \
    PTR64=1 \
    BIGENDIAN=1
endif

ifeq ($(DEB_HOST_ARCH),sparc)
DEB_OPTS += \
    BIGENDIAN=1
endif

ifeq ($(DEB_HOST_ARCH),sparc64)
DEB_OPTS += \
    PTR64=1 \
    BIGENDIAN=1
endif

ifeq ($(DEB_HOST_ARCH),x32)
DEB_OPTS += \
    FORCE_DRC_C_BACKEND= \
    NOASM=
endif

# kFreeBSD architectures
ifeq ($(DEB_HOST_ARCH),kfreebsd-amd64)
DEB_OPTS += \
    TARGETOS=freebsd \
    FORCE_DRC_C_BACKEND= \
    PTR64=1 \
    NOASM= \
    USE_SYSTEM_LIB_PORTMIDI=
export DEB_LDFLAGS_MAINT_APPEND = -ldl
endif

ifeq ($(DEB_HOST_ARCH),kfreebsd-i386)
DEB_OPTS += \
    TARGETOS=freebsd \
    FORCE_DRC_C_BACKEND= \
    NOASM= \
    USE_SYSTEM_LIB_PORTMIDI=
export DEB_LDFLAGS_MAINT_APPEND = -ldl
endif

# GNU/Hurd architecture
ifeq ($(DEB_HOST_ARCH),hurd-i386)
DEB_OPTS += \
    TARGETOS=gnu \
    FORCE_DRC_C_BACKEND= \
    NOASM= \
    USE_SYSTEM_LIB_PORTMIDI= \
    NO_USE_MIDI=1
endif

DEB_MAME_OPTS = \
    SDL_INI_PATH=/etc/mame \
    FULLNAME=mame \
    TARGET=mame \
    SUBTARGET=mame \
    TOOLS=1

ifndef DEBUG
# Disable -g entirely
CFLAGS := $(CFLAGS:-g=-g0)
endif

%:
	dh $@

override_dh_auto_build-arch:
	$(MAKE) $(DEB_OPTS) $(DEB_MAME_OPTS)
	-mv mame64 mame #FIXME
	$(CURDIR)/mame -createconfig
	mv mame.ini default.mame.ini
	mv plugin.ini default.plugin.ini
	mv ui.ini default.ui.ini

override_dh_auto_build-indep:
	$(MAKE) -C docs singlehtml

override_dh_auto_test-arch:
	# Run MAME's internal validation tests
	-$(CURDIR)/mame -validate

override_dh_install:
	dh_install --fail-missing \
		   --exclude=dir.txt \
		   --exclude=LICENSE \
		   --exclude=README.md

override_dh_fixperms-arch:
	dh_fixperms
	find debian/mame/etc/mame -type f -execdir chmod 644 {} \;

override_dh_fixperms-indep:
	dh_fixperms
	find debian/mame-data/usr/share/games/mame/artwork -type f -execdir chmod 644 {} \;
	find debian/mame-data/usr/share/games/mame/bgfx -type f -execdir chmod 644 {} \;
	find debian/mame-data/usr/share/games/mame/ctrlr -type f -execdir chmod 644 {} \;
	find debian/mame-data/usr/share/games/mame/fonts -type f -execdir chmod 644 {} \;
	find debian/mame-data/usr/share/games/mame/hash -type f -execdir chmod 644 {} \;
	find debian/mame-data/usr/share/games/mame/keymaps -type f -execdir chmod 644 {} \;
	find debian/mame-data/usr/share/games/mame/language -type f -name "*.po" -delete
	find debian/mame-data/usr/share/games/mame/language -type f -execdir chmod 644 {} \;
	find debian/mame-data/usr/share/games/mame/plugins -type f -execdir chmod 644 {} \;

PKD := $(abspath $(dir $(MAKEFILE_LIST)))
VER ?= $(shell dpkg-parsechangelog -l$(PKD)/changelog --show-field=Version | sed -e 's/\(.*\)-.*/\1/')

.PHONY: get-orig-source
get-orig-source:
	uscan --noconf --verbose --rename --destdir=$(CURDIR) \
        --check-dirname-level=0 --overwrite-download \
        --download-version $(VER) $(PKD)

## mame 0.188+dfsg.1

=== 3rdparty/bgfx/3rdparty/glslang/CMakeLists.txt ===
cmake_minimum_required(VERSION 2.8.11)
set_property(GLOBAL PROPERTY USE_FOLDERS ON)

option(ENABLE_AMD_EXTENSIONS "Enables support of AMD-specific extensions" ON)
option(ENABLE_GLSLANG_BINARIES "Builds glslangValidator and spirv-remap" ON)

option(ENABLE_NV_EXTENSIONS "Enables support of Nvidia-specific extensions" ON)

option(ENABLE_HLSL "Enables HLSL input support" ON)

enable_testing()

set(CMAKE_INSTALL_PREFIX "install" CACHE STRING "prefix")

project(glslang)

if(ENABLE_AMD_EXTENSIONS)
    add_definitions(-DAMD_EXTENSIONS)
endif(ENABLE_AMD_EXTENSIONS)

if(ENABLE_NV_EXTENSIONS)
    add_definitions(-DNV_EXTENSIONS)
endif(ENABLE_NV_EXTENSIONS)

if(ENABLE_HLSL)
    add_definitions(-DENABLE_HLSL)
endif(ENABLE_HLSL)

if(WIN32)
    set(CMAKE_DEBUG_POSTFIX "d")
    if(MSVC)
        include(ChooseMSVCCRT.cmake)
    endif(MSVC)
    add_definitions(-DGLSLANG_OSINCLUDE_WIN32)
elseif(UNIX)
    add_definitions(-fPIC)
    add_definitions(-DGLSLANG_OSINCLUDE_UNIX)
else(WIN32)
    message("unknown platform")
endif(WIN32)

if(CMAKE_COMPILER_IS_GNUCXX)
    add_definitions(-Wall -Wmaybe-uninitialized -Wuninitialized -Wunused -Wunused-local-typedefs
      -Wunused-parameter -Wunused-value  -Wunused-variable -Wunused-but-set-parameter -Wunused-but-set-variable)
    add_definitions(-Wno-reorder)  # disable this from -Wall, since it happens all over.
    add_definitions(-std=c++11)
elseif(${CMAKE_CXX_COMPILER_ID} MATCHES "Clang")
    add_definitions(-Wall -Wuninitialized -Wunused -Wunused-local-typedefs
      -Wunused-parameter -Wunused-value  -Wunused-variable)
    add_definitions(-Wno-reorder)  # disable this from -Wall, since it happens all over.
    add_definitions(-std=c++11)
endif()

function(glslang_set_link_args TARGET)
    # For MinGW compiles, statically link against the GCC and C++ runtimes.
    # This avoids the need to ship those runtimes as DLLs.
    if(WIN32)
	if(${CMAKE_CXX_COMPILER_ID} MATCHES "GNU")
	    set_target_properties(${TARGET} PROPERTIES
		    LINK_FLAGS "-static -static-libgcc -static-libstdc++")
        endif()
    endif(WIN32)
endfunction(glslang_set_link_args)

# We depend on these for later projects, so they should come first.
add_subdirectory(External)

add_subdirectory(glslang)
add_subdirectory(OGLCompilersDLL)
if(ENABLE_GLSLANG_BINARIES)
	add_subdirectory(StandAlone)
endif()
add_subdirectory(SPIRV)
if(ENABLE_HLSL)
    add_subdirectory(hlsl)
endif(ENABLE_HLSL)
add_subdirectory(gtests)

=== debian/changelog ===
mame (0.188+dfsg.1-0ubuntu2) artful; urgency=medium

  * New upstream release.
  * Refreshed hurd.patch.
  * Removed optimizations for i386 (reduces VM memory requirements).
  * Reinstate mess dummy package, solves mess-desktop-entries pkg dep issue.

 -- Cesare Falco <c.falco@ubuntu.com>  Fri, 28 Jul 2017 13:05:51 +0200

=== debian/control ===
--- 
+++ 
@@ -1,10 +1,8 @@
 Source: mame
 Section: games
 Priority: optional
-Maintainer: Debian Games Team <pkg-games-devel@lists.alioth.debian.org>
-Uploaders: Cesare Falco <c.falco@ubuntu.com>,
- Emmanuel Kasper <emmanuel@libera.cc>,
- Jordi Mallach <jordi@debian.org>
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: Cesare Falco <c.falco@ubuntu.com>
 Build-Depends: debhelper (>= 10),
  dpkg-dev (>= 1.17),
  libexpat1-dev,
@@ -96,3 +94,11 @@
  arcade machines (it is not a simulation).
  .
  This is sphinx-generated full documentation for the MAME system.
+
+Package: mess
+Depends: mame, ${misc:Depends}
+Architecture: all
+Priority: extra
+Section: oldlibs
+Description: Transitional dummy package
+ This is a transitional dummy package. It can safely be removed.

=== debian/rules ===
--- 
+++ 
@@ -67,6 +67,7 @@
 
 ifeq ($(DEB_HOST_ARCH),i386)
 DEB_OPTS += \
+    OPTIMIZE=0 \
     FORCE_DRC_C_BACKEND= \
     NOASM=
 endif

## mame 0.195+dfsg.1

=== 3rdparty/luafilesystem/Makefile ===
# $Id: Makefile,v 1.36 2009/09/21 17:02:44 mascarenhas Exp $

T= lfs

CONFIG= ./config

include $(CONFIG)

SRCS= src/$T.c
OBJS= src/$T.o

lib: src/lfs.so

src/lfs.so: $(OBJS)
	MACOSX_DEPLOYMENT_TARGET="10.3"; export MACOSX_DEPLOYMENT_TARGET; $(CC) $(CFLAGS) $(LIB_OPTION) -o src/lfs.so $(OBJS)

test: lib
	LUA_CPATH=./src/?.so lua tests/test.lua

install:
	mkdir -p $(LUA_LIBDIR)
	cp src/lfs.so $(LUA_LIBDIR)

clean:
	rm -f src/lfs.so $(OBJS)

=== 3rdparty/bgfx/3rdparty/glslang/CMakeLists.txt ===
# increase to 3.1 once all major distributions
# include a version of CMake >= 3.1
cmake_minimum_required(VERSION 2.8.12)
if (POLICY CMP0048)
  cmake_policy(SET CMP0048 NEW)
endif()
set_property(GLOBAL PROPERTY USE_FOLDERS ON)

# Adhere to GNU filesystem layout conventions
include(GNUInstallDirs)

option(SKIP_GLSLANG_INSTALL "Skip installation" ${SKIP_GLSLANG_INSTALL})
if(NOT ${SKIP_GLSLANG_INSTALL})
  set(ENABLE_GLSLANG_INSTALL ON)
endif()

option(ENABLE_AMD_EXTENSIONS "Enables support of AMD-specific extensions" ON)
option(ENABLE_GLSLANG_BINARIES "Builds glslangValidator and spirv-remap" ON)

option(ENABLE_NV_EXTENSIONS "Enables support of Nvidia-specific extensions" ON)

option(ENABLE_HLSL "Enables HLSL input support" ON)

option(ENABLE_OPT "Enables spirv-opt capability if present" ON)

if(CMAKE_INSTALL_PREFIX_INITIALIZED_TO_DEFAULT AND WIN32)
    set(CMAKE_INSTALL_PREFIX "install" CACHE STRING "..." FORCE)
endif()

project(glslang)
# make testing optional
include(CTest)

if(ENABLE_AMD_EXTENSIONS)
    add_definitions(-DAMD_EXTENSIONS)
endif(ENABLE_AMD_EXTENSIONS)

if(ENABLE_NV_EXTENSIONS)
    add_definitions(-DNV_EXTENSIONS)
endif(ENABLE_NV_EXTENSIONS)

if(ENABLE_HLSL)
    add_definitions(-DENABLE_HLSL)
endif(ENABLE_HLSL)

if(WIN32)
    set(CMAKE_DEBUG_POSTFIX "d")
    if(MSVC)
        include(ChooseMSVCCRT.cmake)
    endif(MSVC)
    add_definitions(-DGLSLANG_OSINCLUDE_WIN32)
elseif(UNIX)
    add_definitions(-DGLSLANG_OSINCLUDE_UNIX)
else(WIN32)
    message("unknown platform")
endif(WIN32)

if(${CMAKE_CXX_COMPILER_ID} MATCHES "GNU")
    add_compile_options(-Wall -Wmaybe-uninitialized -Wuninitialized -Wunused -Wunused-local-typedefs
                        -Wunused-parameter -Wunused-value  -Wunused-variable -Wunused-but-set-parameter -Wunused-but-set-variable -fno-exceptions)
    add_compile_options(-Wno-reorder)  # disable this from -Wall, since it happens all over.
elseif(${CMAKE_CXX_COMPILER_ID} MATCHES "Clang")
    add_compile_options(-Wall -Wuninitialized -Wunused -Wunused-local-typedefs
                        -Wunused-parameter -Wunused-value  -Wunused-variable)
    add_compile_options(-Wno-reorder)  # disable this from -Wall, since it happens all over.
endif()

# Request C++11
if(${CMAKE_VERSION} VERSION_LESS 3.1)
    # CMake versions before 3.1 do not understand CMAKE_CXX_STANDARD
    # remove this block once CMake >=3.1 has fixated in the ecosystem
    add_compile_options(-std=c++11)
else()
    set(CMAKE_CXX_STANDARD 11)
    set(CMAKE_CXX_STANDARD_REQUIRED ON)
    set(CMAKE_CXX_EXTENSIONS OFF)
endif()

function(glslang_set_link_args TARGET)
    # For MinGW compiles, statically link against the GCC and C++ runtimes.
    # This avoids the need to ship those runtimes as DLLs.
    if(WIN32 AND ${CMAKE_CXX_COMPILER_ID} MATCHES "GNU")
        set_target_properties(${TARGET} PROPERTIES
                              LINK_FLAGS "-static -static-libgcc -static-libstdc++")
    endif()
endfunction(glslang_set_link_args)

# We depend on these for later projects, so they should come first.
add_subdirectory(External)

if(NOT TARGET SPIRV-Tools-opt)
    set(ENABLE_OPT OFF)
endif()

if(ENABLE_OPT)
    message(STATUS "optimizer enabled")
    add_definitions(-DENABLE_OPT)
elseif(ENABLE_HLSL)
    message(STATUS "spirv-tools not linked - illegal SPIRV may be generated for HLSL")
endif()

add_subdirectory(glslang)
add_subdirectory(OGLCompilersDLL)
if(ENABLE_GLSLANG_BINARIES)
    add_subdirectory(StandAlone)
endif()
add_subdirectory(SPIRV)
if(ENABLE_HLSL)
    add_subdirectory(hlsl)
endif(ENABLE_HLSL)
add_subdirectory(gtests)

=== 3rdparty/bgfx/3rdparty/glslang/StandAlone/CMakeLists.txt ===
add_library(glslang-default-resource-limits
            ${CMAKE_CURRENT_SOURCE_DIR}/ResourceLimits.cpp)
set_property(TARGET glslang-default-resource-limits PROPERTY FOLDER glslang)
set_property(TARGET glslang-default-resource-limits PROPERTY POSITION_INDEPENDENT_CODE ON)

target_include_directories(glslang-default-resource-limits
                           PUBLIC ${CMAKE_CURRENT_SOURCE_DIR}
                           PUBLIC ${PROJECT_SOURCE_DIR})

set(SOURCES StandAlone.cpp DirStackFileIncluder.h)
set(REMAPPER_SOURCES spirv-remap.cpp)

add_executable(glslangValidator ${SOURCES})
add_executable(spirv-remap ${REMAPPER_SOURCES})
set_property(TARGET glslangValidator PROPERTY FOLDER tools)
set_property(TARGET spirv-remap PROPERTY FOLDER tools)
glslang_set_link_args(glslangValidator)
glslang_set_link_args(spirv-remap)

set(LIBRARIES
    glslang
    SPIRV
    SPVRemapper
    glslang-default-resource-limits)

if(WIN32)
    set(LIBRARIES ${LIBRARIES} psapi)
elseif(UNIX)
    if(NOT ANDROID)
        set(LIBRARIES ${LIBRARIES} pthread)
    endif()
endif(WIN32)

target_link_libraries(glslangValidator ${LIBRARIES})
target_link_libraries(spirv-remap ${LIBRARIES})

if(WIN32)
    source_group("Source" FILES ${SOURCES})
endif(WIN32)

if(ENABLE_GLSLANG_INSTALL)
    install(TARGETS glslangValidator
            RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR})

    install(TARGETS spirv-remap
            RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR})
endif(ENABLE_GLSLANG_INSTALL)

=== 3rdparty/bgfx/3rdparty/glslang/glslang/CMakeLists.txt ===
if(WIN32)
    add_subdirectory(OSDependent/Windows)
elseif(UNIX)
    add_subdirectory(OSDependent/Unix)
else(WIN32)
    message("unknown platform")
endif(WIN32)

set(SOURCES
    MachineIndependent/glslang.y
    MachineIndependent/glslang_tab.cpp
    MachineIndependent/Constant.cpp
    MachineIndependent/iomapper.cpp
    MachineIndependent/InfoSink.cpp
    MachineIndependent/Initialize.cpp
    MachineIndependent/IntermTraverse.cpp
    MachineIndependent/Intermediate.cpp
    MachineIndependent/ParseContextBase.cpp
    MachineIndependent/ParseHelper.cpp
    MachineIndependent/PoolAlloc.cpp
    MachineIndependent/RemoveTree.cpp
    MachineIndependent/Scan.cpp
    MachineIndependent/ShaderLang.cpp
    MachineIndependent/SymbolTable.cpp
    MachineIndependent/Versions.cpp
    MachineIndependent/intermOut.cpp
    MachineIndependent/limits.cpp
    MachineIndependent/linkValidate.cpp
    MachineIndependent/parseConst.cpp
    MachineIndependent/reflection.cpp
    MachineIndependent/preprocessor/Pp.cpp
    MachineIndependent/preprocessor/PpAtom.cpp
    MachineIndependent/preprocessor/PpContext.cpp
    MachineIndependent/preprocessor/PpScanner.cpp
    MachineIndependent/preprocessor/PpTokens.cpp
    MachineIndependent/propagateNoContraction.cpp
    GenericCodeGen/CodeGen.cpp
    GenericCodeGen/Link.cpp)

set(HEADERS
    Public/ShaderLang.h
    Include/arrays.h
    Include/BaseTypes.h
    Include/Common.h
    Include/ConstantUnion.h
    Include/InfoSink.h
    Include/InitializeGlobals.h
    Include/intermediate.h
    Include/PoolAlloc.h
    Include/ResourceLimits.h
    Include/revision.h
    Include/ShHandle.h
    Include/Types.h
    MachineIndependent/glslang_tab.cpp.h
    MachineIndependent/gl_types.h
    MachineIndependent/Initialize.h
    MachineIndependent/iomapper.h
    MachineIndependent/LiveTraverser.h
    MachineIndependent/localintermediate.h
    MachineIndependent/ParseHelper.h
    MachineIndependent/reflection.h
    MachineIndependent/RemoveTree.h
    MachineIndependent/Scan.h
    MachineIndependent/ScanContext.h
    MachineIndependent/SymbolTable.h
    MachineIndependent/Versions.h
    MachineIndependent/parseVersions.h
    MachineIndependent/propagateNoContraction.h
    MachineIndependent/preprocessor/PpContext.h
    MachineIndependent/preprocessor/PpTokens.h)

# This might be useful for making grammar changes:
#
# find_package(BISON)
# add_custom_command(OUTPUT ${CMAKE_CURRENT_SOURCE_DIR}/MachineIndependent/glslang_tab.cpp ${CMAKE_CURRENT_SOURCE_DIR}/MachineIndependent/glslang_tab.cpp.h
#                    COMMAND ${BISON_EXECUTABLE} --defines=${CMAKE_CURRENT_SOURCE_DIR}/MachineIndependent/glslang_tab.cpp.h -t ${CMAKE_CURRENT_SOURCE_DIR}/MachineIndependent/glslang.y -o ${CMAKE_CURRENT_SOURCE_DIR}/MachineIndependent/glslang_tab.cpp
#                    MAIN_DEPENDENCY MachineIndependent/glslang.y
#                    WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR})
# set(BISON_GLSLParser_OUTPUT_SOURCE ${CMAKE_CURRENT_SOURCE_DIR}/MachineIndependent/glslang_tab.cpp)

add_library(glslang STATIC ${BISON_GLSLParser_OUTPUT_SOURCE} ${SOURCES} ${HEADERS})
set_property(TARGET glslang PROPERTY FOLDER glslang)
set_property(TARGET glslang PROPERTY POSITION_INDEPENDENT_CODE ON)
target_link_libraries(glslang OGLCompiler OSDependent)
if(ENABLE_HLSL)
    target_link_libraries(glslang HLSL)
endif()

if(WIN32)
    source_group("Public" REGULAR_EXPRESSION "Public/*")
    source_group("MachineIndependent" REGULAR_EXPRESSION "MachineIndependent/[^/]*")
    source_group("Include" REGULAR_EXPRESSION "Include/[^/]*")
    source_group("GenericCodeGen" REGULAR_EXPRESSION "GenericCodeGen/*")
    source_group("MachineIndependent\\Preprocessor" REGULAR_EXPRESSION "MachineIndependent/preprocessor/*")
endif(WIN32)

if(ENABLE_GLSLANG_INSTALL)
    install(TARGETS glslang
            ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR})
endif(ENABLE_GLSLANG_INSTALL)

if(ENABLE_GLSLANG_INSTALL)
    foreach(file ${HEADERS})
        get_filename_component(dir ${file} DIRECTORY)
        install(FILES ${file} DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}/glslang/${dir})
    endforeach()
endif(ENABLE_GLSLANG_INSTALL)

=== 3rdparty/bgfx/3rdparty/glslang/glslang/OSDependent/Unix/CMakeLists.txt ===
add_library(OSDependent STATIC ossource.cpp ../osinclude.h)
set_property(TARGET OSDependent PROPERTY FOLDER glslang)
set_property(TARGET OSDependent PROPERTY POSITION_INDEPENDENT_CODE ON)

if(ENABLE_GLSLANG_INSTALL)
    install(TARGETS OSDependent
            ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR})
endif(ENABLE_GLSLANG_INSTALL)

=== debian/changelog ===
mame (0.195+dfsg.1-2) unstable; urgency=medium

  [ Cesare Falco ]
  * Use Gold linker and set ld flags to reduce memory.

  [ Jordi Mallach ]
  * Add B-D-I on python3-distutils so Sphynx works as expected.
  * Move links and doc-base paths to new default location of docs.
  * Add patch to fix an infinite loop in the fallback C code for
    mips*, arm*, s390x, and other arches with no native ASM. This
    fixes the validation tests for the check build rule.
  * Set OPTIMIZE=2 to avoid memory exhaustion on i386 builds.
  * Upload to unstable, rapidjson (>= 1.0) is now available there.

 -- Jordi Mallach <jordi@debian.org>  Thu, 22 Mar 2018 22:26:55 +0100

mame (0.195+dfsg.1-1) experimental; urgency=medium

  [ Cesare Falco ]
  * New upstream release.
  * Use Gold linker and set ld flags to reduce memory requirements

  [ Jordi Mallach ]
  * Reinstate check rule, as a failure to run indicates grave problems
    in the generated binary.
  * Remove transitional mess package again, as mess-desktop-entries has
    been fixed.
  * Use system libglm, rapidjson and utf8proc. Drop definitions for system
    libuv which is no longer used (closes: #892559).
  * Drop avoid_linenoise.patch and build definitions, as the bundled
    linenoise fork no longer has GPL-incompatible material.
  * Apply several formatting fixes to copyright file.
  * Bump debhelper compat to v11.

 -- Jordi Mallach <jordi@debian.org>  Sat, 17 Mar 2018 01:31:35 +0100

mame (0.194+dfsg.1-1) UNRELEASED; urgency=medium

  * New upstream release.
  * Update patches.

  [ Jordi Mallach ]
  * Reinstate check rule, as a failure to run indicates grave problems
    in the generated binary.
  * Remove transitional mess package again, as mess-desktop-entries has
    been fixed.

 -- Cesare Falco <c.falco@ubuntu.com>  Wed, 31 Jan 2018 12:08:01 +0100

mame (0.193+dfsg.1-1) UNRELEASED; urgency=medium

  * New upstream release.
  * debian/rules: removed Mame internal testing, seems to break ARM builds.

 -- Cesare Falco <c.falco@ubuntu.com>  Thu, 28 Dec 2017 16:21:38 +0100

mame (0.192+dfsg.1-1) UNRELEASED; urgency=medium

  * New upstream release.

 -- Cesare Falco <c.falco@ubuntu.com>  Sun, 03 Dec 2017 22:24:20 +0100

mame (0.190+dfsg.1-1) unstable; urgency=medium

  * New upstream release.

 -- Cesare Falco <c.falco@ubuntu.com>  Sat, 30 Sep 2017 18:37:49 +0200

mame (0.189+dfsg.1-2) unstable; urgency=medium

  * Reinstate mess dummy package, solves mess-desktop-entries pkg dep issue.
  * Include ctrlr directory in mame-data.
  * Refreshed avoid_linenoise.patch.

 -- Cesare Falco <c.falco@ubuntu.com>  Sun, 17 Sep 2017 12:09:18 +0200

mame (0.189+dfsg.1-1) unstable; urgency=medium

  * New upstream release.

 -- Jordi Mallach <jordi@debian.org>  Wed, 30 Aug 2017 17:54:29 +0200

mame (0.188+dfsg.1-1) unstable; urgency=medium

  * New upstream release.
  * Refreshed hurd.patch.
  * Removed optimizations for i386 (reduces VM memory requirements;
    closes: #869074).

 -- Cesare Falco <c.falco@ubuntu.com>  Fri, 28 Jul 2017 13:05:51 +0200

=== debian/control ===
--- 
+++ 
@@ -1,13 +1,16 @@
 Source: mame
 Section: games
 Priority: optional
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: Cesare Falco <c.falco@ubuntu.com>
-Build-Depends: debhelper (>= 10),
+Maintainer: Debian Games Team <pkg-games-devel@lists.alioth.debian.org>
+Uploaders: Cesare Falco <c.falco@ubuntu.com>,
+ Emmanuel Kasper <emmanuel@libera.cc>,
+ Jordi Mallach <jordi@debian.org>
+Build-Depends: debhelper (>= 11),
  dpkg-dev (>= 1.17),
  libexpat1-dev,
  libflac-dev,
  libfontconfig1-dev,
+ libglm-dev,
  libjpeg-dev,
  liblua5.3-dev,
  libportmidi-dev [linux-any],
@@ -15,11 +18,12 @@
  libsdl2-dev,
  libsqlite3-dev,
  libutil-freebsd-dev [kfreebsd-any],
- libuv1-dev,
+ libutf8proc-dev,
  libxinerama-dev,
  portaudio19-dev,
  python-dev,
  qtbase5-dev,
+ rapidjson-dev (>= 1.0),
  zlib1g-dev
 Build-Depends-Indep: python3-sphinx
 Standards-Version: 3.9.8
@@ -94,11 +98,3 @@
  arcade machines (it is not a simulation).
  .
  This is sphinx-generated full documentation for the MAME system.
-
-Package: mess
-Depends: mame, ${misc:Depends}
-Architecture: all
-Priority: extra
-Section: oldlibs
-Description: Transitional dummy package
- This is a transitional dummy package. It can safely be removed.

=== debian/rules ===
--- 
+++ 
@@ -19,7 +19,11 @@
 export DEB_CFLAGS_MAINT_APPEND = $(shell dpkg-buildflags --get CPPFLAGS)
 
 # Sacrifice linking speed to avoid using so much memory
-export DEB_LDFLAGS_MAINT_APPEND = -Wl,--no-keep-memory
+export DEB_LDFLAGS_MAINT_APPEND = \
+    -Wl,--no-keep-memory,--reduce-memory-overheads,--hash-size=31
+
+# Also, use Gold linker which is less greed for memory
+LDFLAGS = "-fuse-ld=gold"
 
 # taken verbatim from debian policy
 ifneq (,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
@@ -38,7 +42,6 @@
     PTR64= \
     BIGENDIAN= \
     NOASM=1 \
-    NO_USE_LINENOISE=1 \
     QT_HOME=/usr/lib/$(DEB_HOST_MULTIARCH)/qt5/ \
     USE_SYSTEM_LIB_EXPAT=1 \
     USE_SYSTEM_LIB_ZLIB=1 \
@@ -48,7 +51,9 @@
     USE_SYSTEM_LIB_SQLITE3=1 \
     USE_SYSTEM_LIB_PORTMIDI=1 \
     USE_SYSTEM_LIB_PORTAUDIO=1 \
-    USE_SYSTEM_LIB_UV=1 \
+    USE_SYSTEM_LIB_GLM=1 \
+    USE_SYSTEM_LIB_RAPIDJSON=1 \
+    USE_SYSTEM_LIB_UTF8PROC=1 \
     VERBOSE=1
 
 # Override make variables for specific archs
@@ -67,7 +72,7 @@
 
 ifeq ($(DEB_HOST_ARCH),i386)
 DEB_OPTS += \
-    OPTIMIZE=0 \
+    OPTIMIZE=2 \
     FORCE_DRC_C_BACKEND= \
     NOASM=
 endif

=== debian/watch ===
version=4
opts="dversionmangle=s/\+dfsg$//,repacksuffix=+dfsg.1,repack,compression=xz" \
    https://github.com/mamedev/mame/tags/ \
        .+@PACKAGE@(\d)(\d{3})\.tar\.gz debian uupdate

## mame 0.199+dfsg.1

=== debian/changelog ===
mame (0.199+dfsg.1-1) unstable; urgency=medium

  * New upstream release.

 -- Jordi Mallach <jordi@debian.org>  Fri, 20 Jul 2018 16:25:34 +0200

mame (0.196+dfsg.1-1) unstable; urgency=medium

  * New upstream release.
  * Update Vcs-* fields to reflect migration to salsa.debian.org.
  * Remove fix_c_fallback.patch, which was taken from git.

 -- Jordi Mallach <jordi@debian.org>  Fri, 20 Jul 2018 12:13:33 +0200

=== debian/control ===
--- 
+++ 
@@ -27,8 +27,8 @@
  zlib1g-dev
 Build-Depends-Indep: python3-sphinx
 Standards-Version: 3.9.8
-Vcs-Git: https://anonscm.debian.org/git/pkg-games/mame.git
-Vcs-Browser: https://anonscm.debian.org/cgit/pkg-games/mame.git
+Vcs-Git: https://salsa.debian.org/games-team/mame.git
+Vcs-Browser: https://salsa.debian.org/games-team/mame
 Homepage: http://mamedev.org/
 XS-Autobuild: yes

## mame 0.200+dfsg.1

=== debian/changelog ===
mame (0.200+dfsg.1-1) unstable; urgency=medium

  * New upstream release.
  * Use system libasio and libpugixml. Update B-D accordingly.
  * Make use of the gold linker conditional to availability.
  * Drop usage of system asio, as it does not build with current versions
    in unstable or experimental.

 -- Jordi Mallach <jordi@debian.org>  Wed, 01 Aug 2018 13:41:17 +0200

=== debian/control ===
--- 
+++ 
@@ -14,6 +14,7 @@
  libjpeg-dev,
  liblua5.3-dev,
  libportmidi-dev [linux-any],
+ libpugixml-dev,
  libsdl2-ttf-dev,
  libsdl2-dev,
  libsqlite3-dev,

=== debian/rules ===
--- 
+++ 
@@ -21,9 +21,6 @@
 # Sacrifice linking speed to avoid using so much memory
 export DEB_LDFLAGS_MAINT_APPEND = \
     -Wl,--no-keep-memory,--reduce-memory-overheads,--hash-size=31
-
-# Also, use Gold linker which is less greed for memory
-LDFLAGS = "-fuse-ld=gold"
 
 # taken verbatim from debian policy
 ifneq (,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
@@ -51,23 +48,26 @@
     USE_SYSTEM_LIB_SQLITE3=1 \
     USE_SYSTEM_LIB_PORTMIDI=1 \
     USE_SYSTEM_LIB_PORTAUDIO=1 \
+    USE_SYSTEM_LIB_UTF8PROC=1 \
     USE_SYSTEM_LIB_GLM=1 \
     USE_SYSTEM_LIB_RAPIDJSON=1 \
-    USE_SYSTEM_LIB_UTF8PROC=1 \
+    USE_SYSTEM_LIB_PUGIXML=1 \
     VERBOSE=1
 
-# Override make variables for specific archs
-# Linux architectures
+# Set specific arch options:
+# Use Gold linker which is less greedy for memory
 ifeq ($(DEB_HOST_ARCH),amd64)
 DEB_OPTS += \
     FORCE_DRC_C_BACKEND= \
     PTR64=1 \
     NOASM=
+DEB_LDFLAGS_MAINT_APPEND = "-fuse-ld=gold"
 endif
 
 ifeq ($(DEB_HOST_ARCH),arm64)
 DEB_OPTS += \
     ARCHOPTS="-mabi=lp64 -fPIC"
+DEB_LDFLAGS_MAINT_APPEND = "-fuse-ld=gold"
 endif
 
 ifeq ($(DEB_HOST_ARCH),i386)
@@ -75,6 +75,7 @@
     OPTIMIZE=2 \
     FORCE_DRC_C_BACKEND= \
     NOASM=
+DEB_LDFLAGS_MAINT_APPEND = "-fuse-ld=gold"
 endif
 
 ifeq ($(DEB_HOST_ARCH),ia64)
@@ -93,6 +94,10 @@
     ARCHOPTS=-Umips
 endif
 
+ifeq ($(DEB_HOST_ARCH),mips64el)
+DEB_LDFLAGS_MAINT_APPEND = "-fuse-ld=gold"
+endif
+
 ifeq ($(DEB_HOST_ARCH),powerpc)
 DEB_OPTS += \
     ARCHOPTS=-Upowerpc \
@@ -122,6 +127,7 @@
 DEB_OPTS += \
     PTR64=1 \
     BIGENDIAN=1
+DEB_LDFLAGS_MAINT_APPEND = "-fuse-ld=gold"
 endif
 
 ifeq ($(DEB_HOST_ARCH),sparc)
@@ -139,6 +145,7 @@
 DEB_OPTS += \
     FORCE_DRC_C_BACKEND= \
     NOASM=
+DEB_LDFLAGS_MAINT_APPEND = "-fuse-ld=gold"
 endif
 
 # kFreeBSD architectures

## mame 0.203+dfsg.1

=== debian/changelog ===
mame (0.203+dfsg.1-1~mx17+1) mx; urgency=medium

  * Rebuild for MX 17.

 -- Steven Pusser <stevep@mxlinux.org>  Thu, 03 Jan 2019 18:48:25 -0800

mame (0.203+dfsg.1-1) unstable; urgency=medium

  * New upstream release.
  * Remove leftover cruft from the removal of get-orig-source target.

 -- Jordi Mallach <jordi@debian.org>  Fri, 02 Nov 2018 01:27:47 +0100

mame (0.202+dfsg.1-1) unstable; urgency=medium

  * New upstream release.
  * Upload to unstable.
  * Remove full CC0 text from debian/copyright and add a pointer to
    common-licenses.
  * Remove get-orig-source rule, as it relies on uscan anyway.
  * Really update Standards-Version to 4.2.1 (not 4.1.2!).
  * Do not run uupdate in watch file.
  * Switch from dh_install --fail-missing to dh_missing --fail-missing.

 -- Jordi Mallach <jordi@debian.org>  Sun, 21 Oct 2018 02:44:36 +0200

mame (0.201+dfsg.1-1) experimental; urgency=medium

  * New upstream release.
  * Use HTTPS for links to mamedev.org.
  * Set Rules-Requires-Root to no.
  * Update Standards-Version to 4.2.1.

 -- Jordi Mallach <jordi@debian.org>  Tue, 11 Sep 2018 23:56:25 +0200

=== debian/control ===
--- 
+++ 
@@ -1,7 +1,8 @@
 Source: mame
 Section: games
 Priority: optional
-Maintainer: Debian Games Team <pkg-games-devel@lists.alioth.debian.org>
+Maintainer: Steven Pusser <stevep@mxlinux.org>
+XSBC-Original-Maintainer: Debian Games Team <pkg-games-devel@lists.alioth.debian.org>
 Uploaders: Cesare Falco <c.falco@ubuntu.com>,
  Emmanuel Kasper <emmanuel@libera.cc>,
  Jordi Mallach <jordi@debian.org>
@@ -27,11 +28,12 @@
  rapidjson-dev (>= 1.0),
  zlib1g-dev
 Build-Depends-Indep: python3-sphinx
-Standards-Version: 3.9.8
+Standards-Version: 4.2.1
 Vcs-Git: https://salsa.debian.org/games-team/mame.git
 Vcs-Browser: https://salsa.debian.org/games-team/mame
-Homepage: http://mamedev.org/
+Homepage: https://mamedev.org/
 XS-Autobuild: yes
+Rules-Requires-Root: no
 
 Package: mame
 Architecture: any
